;*********************************************************************************************************
;***  I2C COMMUNICATION
;*********************************************************************************************************
; USES: _N, IOBYTE
; CALL: D60us, D500us

;*** Initialize I2C Bus
I2CINIT	BSF     STATUS,RP0     ; Select Page 1 for TrisB access
        BCF     I2C_C
        BSF     I2C_D
	BCF     STATUS,RP0
        BSF     I2C_C
        BSF     I2C_D
	RETURN


;*** OUTPUT 1 ON I2C BUS (PIN = INPUT)
I2C1:	BSF	STATUS, RP0        
        BSF     I2C_D		; high impedance
	BCF	STATUS, RP0                
	RETURN

;*** OUTPUT 0 ON I2CBUS
I2C0:   BCF     I2C_D
	BSF	STATUS, RP0        
        BCF     I2C_D		; low impedance zero
        BCF	STATUS, RP0
        BCF     I2C_D
	RETURN

;*** SEND I2C START CONDITION
I2CSTA:	CALL	I2C1
        CALL    D60us
        BSF     I2C_C
        CALL    D500us
        CALL    I2C0
        CALL    D60us
        BCF     I2C_C
	RETURN

;*** SEND I2C STOP CONDITION
I2CSTO: CALL    I2C0
        CALL    D60us
        BSF     I2C_C
        CALL    D60us
	CALL	I2C1
	RETURN

;*** WRITE BYTE TO I2C BUS
I2CWB:  MOVWF   IOBYTE
        MOVLW   .8
        MOVWF	_N
I2CWB1: RLF     IOBYTE, F
	BTFSS	STATUS, C
	GOTO	I2CWB3
	GOTO	I2CWB4
I2CWB2:	DECFSZ	_N, F
	GOTO	I2CWB1
	CALL	I2C1		; read ACK bit...
        CALL    D60us
        BSF     I2C_C
        CALL    D60us
        BCF     I2C_C
        CALL    D60us	
	RETURN
I2CWB3:	CALL	I2C0		; bring DATA_PIN low
        CALL    D60us
        BSF     I2C_C
        CALL    D60us	
        BCF     I2C_C
        GOTO    I2CWB2
I2CWB4:	CALL	I2C1
        CALL    D60us
        BSF     I2C_C
        CALL    D60us
        BCF     I2C_C
        GOTO    I2CWB2

;*** READ BYTE FROM I2C BUS
I2CRB:  CALL    I2C1
        MOVLW   .8
	MOVWF	 _N
        CLRF    IOBYTE
I2CRB1: BSF     I2C_C
        CALL    D60us
        BSF     STATUS,C
        BTFSS   I2C_D
        BCF     STATUS,C
        RLF     IOBYTE,F
        BCF     I2C_C
        CALL    D60us
        DECFSZ  _N, F
        GOTO    I2CRB1
        CALL    I2C0
        CALL    D60us
        BSF     I2C_C     ; ACK-bit
        CALL    D60us
        BCF     I2C_C
        CALL    D60us	
        CALL    I2C1
        CALL    D60us
        MOVFW   IOBYTE          ; return the result in W
	RETURN

;*** READ LAST BYTE FROM I2C BUS (NO ACK)
I2CRL:  CALL    I2C1
        MOVLW   .8
	MOVWF	 _N
        CLRF    IOBYTE
I2CRL1: BSF     I2C_C
        CALL    D60us
        BSF     STATUS,C
        BTFSS   I2C_D
        BCF     STATUS,C
        RLF     IOBYTE,F
        BCF     I2C_C
        CALL    D60us
        DECFSZ  _N, F
        GOTO    I2CRL1
        CALL    I2C0
        CALL    D60us
        BSF     I2C_C     ; ACK-bit
        CALL    D60us
        CALL    I2C1
        MOVFW   IOBYTE          ; return the result in W
	RETURN
